package xlogo.kernel;

import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Image;
import java.awt.MediaTracker;
import java.awt.Point;
import java.awt.Rectangle;
import java.awt.RenderingHints;
import java.awt.Shape;
import java.awt.Stroke;
import java.awt.Toolkit;
import java.awt.geom.Arc2D;
import java.awt.geom.Line2D;
import java.awt.Dimension;
import java.awt.geom.Rectangle2D;
import java.awt.image.BufferedImage;
import javax.swing.SwingUtilities;
import javax.swing.JPanel;
import java.util.Stack;
import java.util.Set;
import java.util.Iterator;
import java.util.StringTokenizer;
import java.awt.event.*;
import xlogo.Application;
import xlogo.gui.preferences.Panel_Font;
import xlogo.utils.Utils;
import xlogo.utils.myException;
import xlogo.Config;
import xlogo.Logo;
import xlogo.kernel.gui.*;


/**
 * Title :        XLogo
 * Description :  XLogo is an interpreter for the Logo 
 * 						programming language
 * @author Loïc Le Coq
 */
 public class DrawPanel extends JPanel {
	private static final long serialVersionUID = 1L;
	public Turtle tortue;
	public Turtle[] tortues; 
	public Stack tortues_visibles;

	//0 si mode fenetre 1 si mode enroule 2 si mode clos
	protected static int etat_fenetre = 0;
	protected static final int WINDOW_CLASSIC=0;
	protected static final int WINDOW_WRAP=1;
	protected static final int WINDOW_CLOSE=2;
	

	// Boolean for animation mode
	public static boolean classicMode=true; // true si classique false si animation
	public final static boolean MODE_ANIMATION=false;
	public final static boolean MODE_CLASSIC=true;


	// default predefined colors 
	public static final Color[] defaultColors={Color.BLACK,Color.RED,Color.GREEN,Color.YELLOW,Color.BLUE,
			Color.MAGENTA,Color.CYAN,Color.WHITE,Color.GRAY,Color.LIGHT_GRAY,new Color(128,0,0),new Color(0,128,0),
			new Color(0,0,128),new Color(255,128,0),Color.PINK,new Color(128,0,255),new Color(153,102,0)};

	
	// The id for the drawing font (with primitive label)
	protected int police_etiquette;
	private Color couleurfond = Color.white;
	
	private Shape shape=null;

	private Line2D line; 
	private Rectangle2D rec;
	private Application cadre;
	// DoubleBuffering
	// image and Graphics of the BufferedImage for the drawing
	public static BufferedImage dessin;
	private Graphics2D g;
	// The scale for the zoom
	public static double zoom=1;
	private GuiMap gm;

	private BasicStroke crayon_triangle = new BasicStroke(1);
	private double[] coords;
	private double oldx, oldy,x1,y1,x2,y2;
	// Were used for clipping
	//	private double nx,ny,vx,vy,factor,length;
	//	private GeneralPath gp;
	// private Arc2D clipArc;
		private Arc2D arc;
	
	private int bouton_souris=0;  	// Numéro du bouton de souris appuyé sur la zone de dessin
	private String possouris="[ 0 0 ] ";	// Coordonnées du point du dernier événement souris
	
	public static boolean showTurtle=true;

	private	Click_Souris cs=new Click_Souris();
	private Bouge_Souris bs=new Bouge_Souris();
	private boolean lissouris=false; //Indique si un événement souris est intervenu depuis le debut du programme
	public DrawPanel(Application cadre){
		this.gm=cadre.getKernel().getWorkspace().getGuiMap();
		 setLayout(null);
		 this.setPreferredSize(new Dimension(
				 (int)(Config.imageWidth*zoom),(int)( Config.imageHeight*zoom)));
		 this.cadre=cadre;
		initGraphics();
	}
	protected void av(double arg) {
	//	Graphics2D g=(Graphics2D)dessin.getGraphics();
		oldx = tortue.corX;
		oldy = tortue.corY;
		if (DrawPanel.etat_fenetre == DrawPanel.WINDOW_CLASSIC) { //mode fenetre
					montrecacheTortue(false);
			tortue.corX = tortue.corX + arg
					* Math.cos(tortue.angle);
			tortue.corY = tortue.corY - arg
					* Math.sin(tortue.angle);
			if (tortue.isPenDown()) {
				if (tortue.isPenReverse()) {
					g.setColor(couleurfond);
					g.setXORMode(tortue.couleurcrayon);
				} else {
					g.setColor(tortue.couleurcrayon);
					g.setPaintMode();
				}
				if (null==line) line=new Line2D.Double();
			/*	if (null==gp) gp=new GeneralPath();
				else gp.reset();*/
				if (oldx < tortue.corX){
					x1=oldx;y1=oldy;x2=tortue.corX;y2=tortue.corY;
				}
				if (oldx>tortue.corX){
					x2=oldx;y2=oldy;x1=tortue.corX;y1=tortue.corY;
				}
				else if (oldx==tortue.corX){
					if (oldy<tortue.corY){
						x2=oldx;y2=oldy;x1=tortue.corX;y1=tortue.corY;						
						}
					else{ 
						x1=oldx;y1=oldy;x2=tortue.corX;y2=tortue.corY;
					}
				}
				
				line.setLine(x1,y1,x2,y2);
								
				/*
				// perpendicular vector
				nx=y1-y2;
				ny=x2-x1;
				length=Math.sqrt(nx*nx+ny*ny);
				if (length!=0){
					factor=(1+tortue.getPenWidth())/length;
					vx=x2-x1;
					vy=y2-y1;
					gp.moveTo((float)(x1-vx*factor-nx*factor),
						(float)(y1-vy*factor-ny*factor));
					gp.lineTo((float)(x1-vx*factor+nx*factor),
						(float)(y1-vy*factor+ny*factor));		
					gp.lineTo((float)(x2+vx*factor+nx*factor),
						(float)(y2+vy*factor+ny*factor));
					gp.lineTo((float)(x2+vx*factor-nx*factor),
						(float)(y2+vy*factor-ny*factor));
					gp.lineTo((float)(x1-vx*factor-nx*factor),
						(float)(y1-vy*factor-ny*factor));	
				}
				else{
					float width=tortue.getPenWidth()+0.5f;
					gp.moveTo((float)(x1-width),
							(float)(y1-width));
					gp.lineTo((float)(x1+width),
							(float)(y1-width));		
					gp.lineTo((float)(x1+width),
							(float)(y1+width));
					gp.lineTo((float)(x1-width),
							(float)(y1+width));
					gp.lineTo((float)(x1-width),
							(float)(y1-width));
				}
				shape=gp;*/
				g.draw(line);
				 //if (!tortue.isVisible()) 
					 clip();
		//		g.dispose();
			}
			montrecacheTortue(true);
		} else if (DrawPanel.etat_fenetre == DrawPanel.WINDOW_WRAP) { //mode enroule
			trace_enroule(arg, oldx, oldy);
		} else if (DrawPanel.etat_fenetre == DrawPanel.WINDOW_CLOSE) { //mode clos
			try {
				trace_ferme(oldx, oldy, arg);
			} catch (myException e) {
			}
		}
	}

	protected void td(double arg) {
//		System.out.println(tortue.angle);
		if (tortue.isVisible())
			montrecacheTortue(false);
		tortue.cap = ((tortue.cap + arg) % 360 + 360) % 360;
		tortue.angle = Math.toRadians(90 - tortue.cap);
		if (tortue.isVisible())
			montrecacheTortue(true);
		Interprete.operande = false;
	}
	protected void arc(double rayon, double pangle, double fangle) {
		// Put fangle and pangle between 0 and 360
		fangle = ((90 - fangle) % 360); 
		pangle = ((90 - pangle) % 360);
		if (fangle<0) fangle+=360;
		if (pangle<0) pangle+=360;
		// Calculate angle extend
		double angle=pangle-fangle;
		if (angle<0) angle+=360;
		montrecacheTortue(false);
		if (null==arc) arc=new Arc2D.Double();
		arc.setArcByCenter(tortue.corX,tortue.corY,rayon,
				fangle,angle, Arc2D.OPEN);
		if (tortue.isPenReverse()) {
			g.setColor(couleurfond);
			g.setXORMode(tortue.couleurcrayon);
		} else {
			g.setColor(tortue.couleurcrayon);
			g.setPaintMode();
		}

		g.draw(arc);
	/*	if (null==gp) gp=new GeneralPath();
		else gp.reset();
		gp.moveTo((float)(tortue.corX-rayon-tortue.getPenWidth()),
				(float)(tortue.corY-rayon-tortue.getPenWidth());
		gp.lineTo((float)(tortue.corX-rayon-tortue.getPenWidth()),
				(float)(tortue.corY-rayon-tortue.getPenWidth()));
		gp.lineTo((float)(tortue.corX-rayon-tortue.getPenWidth()),
				(float)(tortue.corY-rayon-tortue.getPenWidth()));
		gp.lineTo((float)(tortue.corX-rayon-tortue.getPenWidth()),
				(float)(tortue.corY-rayon-tortue.getPenWidth()));
		gp.lineTo((float)(tortue.corX-rayon-tortue.getPenWidth()),
				(float)(tortue.corY-rayon-tortue.getPenWidth()));*/
/*		if (null==rec) rec=new Rectangle2D.Double();
		rec.setRect(tortue.corX-rayon-tortue.getPenWidth(),
			tortue.corY-rayon-tortue.getPenWidth(),
			2*(rayon+tortue.getPenWidth()),2*(rayon+tortue.getPenWidth()));*/
		clip();
		montrecacheTortue(true); 
	}
	protected void circle(double rayon) {
		montrecacheTortue(false);
		if (null==arc) arc=new Arc2D.Double();
		arc.setArcByCenter(tortue.corX,tortue.corY,rayon,
				0,360, Arc2D.OPEN);
		if (tortue.isPenReverse()) {
			g.setColor(couleurfond);
			g.setXORMode(tortue.couleurcrayon);
		} else {
			g.setColor(tortue.couleurcrayon);
			g.setPaintMode();
		}
		g.draw(arc);
	/*	if (null==clipArc) clipArc=new Arc2D.Double();
		clipArc.setArcByCenter(tortue.corX,tortue.corY,
				rayon+2+tortue.getPenWidth(),0,360, Arc2D.OPEN);*/
		clip();
		montrecacheTortue(true); // on efface la tortue si elle st visible
	}

	protected void chargeimage(BufferedImage image) {
		if (tortue.isVisible())
			montrecacheTortue(false);
		g.setPaintMode();
		g.drawImage(image, null, (int) tortue.corX,
				(int) tortue.corY);
		clip();
//		repaint();
/*		if (null==rec) rec=new Rectangle2D.Double();
		rec.setRect(tortue.corX,tortue.corY,
				image.getWidth(),image.getHeight());*/
		if (tortue.isVisible())
			montrecacheTortue(true);
	}

	private double trouve_longueur(double mini, double maxi, double oldx, double oldy) {
		// renvoie la longueur dont on peut encore avancer
		if (Math.abs(maxi - mini) < 0.5){
			return (mini);}
		else {
			double milieu = (mini + maxi) / 2;
			double nx = oldx + milieu * Math.cos(tortue.angle);
			double ny = oldy - milieu * Math.sin(tortue.angle);
			if (nx < 0 || nx > Config.imageWidth|| ny < 0 || ny > Config.imageHeight)
				return trouve_longueur(mini, milieu, oldx, oldy);
			else
				return trouve_longueur(milieu, maxi, oldx, oldy);
		}
	}

	private void trace_enroule(double arg, double oldx, double oldy) {
		boolean re = false;
		if (arg < 0) {
			re = true;
		}
		double diagonale=Math.sqrt(Math.pow(Config.imageWidth,2)+Math.pow(Config.imageHeight,2))+1;
		double longueur;
		if (re)
			longueur = trouve_longueur(0, -diagonale, oldx, oldy);
		else
			longueur = trouve_longueur(0, diagonale, oldx, oldy);
//		System.out.println(diagonale+" "+oldx+" "+oldy);
		while (Math.abs(longueur) < Math.abs(arg)) {
		//	System.out.println(Math.abs(longueur)+" "+Math.abs(arg));
			arg -= longueur;
			DrawPanel.etat_fenetre = DrawPanel.WINDOW_CLASSIC;
			av(longueur);
			//System.out.println(Math.abs(longueur)+" "+Math.abs(arg));
			if (cadre.error)
				break; //permet d'interrompre avec le bouton stop
			DrawPanel.etat_fenetre = DrawPanel.WINDOW_WRAP;
			if (Config.turtleSpeed != 0) {
				try {
					Thread.sleep(Config.turtleSpeed * 5);
				} catch (InterruptedException e) {
				}
			}
			if (tortue.isVisible())
				this.montrecacheTortue(false);
				if (re) tortue.cap=(tortue.cap+180)%360;
			if (tortue.corX > Config.imageWidth-1
					&& (tortue.cap < 180 && tortue.cap != 0)) {
				tortue.corX = 0;
				if (tortue.corY > Config.imageHeight-1
						&& (tortue.cap > 90 && tortue.cap < 270))
					tortue.corY = 0;
				else if (tortue.corY < 1
						&& (tortue.cap < 90 || tortue.cap > 270))
					tortue.corY = Config.imageHeight;
			} else if (tortue.corX < 1 && tortue.cap > 180) {
				tortue.corX = Config.imageWidth;
				if (tortue.corY > Config.imageHeight-1
						&& (tortue.cap > 90 && tortue.cap < 270))
					tortue.corY = 0;
				else if (tortue.corY < 1
						&& (tortue.cap < 90 || tortue.cap > 270))
					tortue.corY = Config.imageHeight;
			} else if (tortue.corY > Config.imageHeight-1)
				tortue.corY = 0;
			else if (tortue.corY < 1)
				tortue.corY = Config.imageHeight;
			if (re) tortue.cap=(tortue.cap+180)%360;
			if (tortue.isVisible())
				this.montrecacheTortue(true);
			if (re)
				longueur = trouve_longueur(0, -diagonale, tortue.corX,
						tortue.corY);
			else
				longueur = trouve_longueur(0, diagonale, tortue.corX,
						tortue.corY);
		}
		DrawPanel.etat_fenetre = DrawPanel.WINDOW_CLASSIC;
		if (!cadre.error)
			av(arg);
		DrawPanel.etat_fenetre = DrawPanel.WINDOW_WRAP;
	}

	private void trace_ferme(double oldx, double oldy, double arg) throws myException {
		boolean re = false;
		double longueur;
		double diagonale=Math.sqrt(Math.pow(Config.imageWidth,2)+Math.pow(Config.imageHeight,2))+1;
		if (arg < 0)
			re = true;
		if (re)
			longueur = trouve_longueur(0, -diagonale, oldx, oldy);
		else
			longueur = trouve_longueur(0, diagonale, oldx, oldy);
		if (Math.abs(longueur) < Math.abs(arg))
			throw new myException(cadre, Logo.messages
					.getString("erreur_sortie1")
					+ "\n"
					+ Logo.messages.getString("erreur_sortie2")
					+ Math.abs((int) (longueur)));
		else {
			DrawPanel.etat_fenetre = DrawPanel.WINDOW_CLASSIC;
			av(arg);
			DrawPanel.etat_fenetre = DrawPanel.WINDOW_CLOSE;
		}
	}
	private void extractCoords(String liste,String prim)throws myException{
		coords[0]=1;
		coords[1]=1;
		StringTokenizer st = new StringTokenizer(liste);
		try {
			if (!st.hasMoreTokens())
				throw new myException(cadre, prim
						+ " " + Logo.messages.getString("n_aime_pas") + liste
						+ Logo.messages.getString("comme_parametre"));
			String li = st.nextToken();
			if (li.equals("-")) {
				if (st.hasMoreTokens())
					li = st.nextToken();
				coords[0] = -1;
			}
			coords[0] = coords[0] * Double.parseDouble(li) + Config.imageWidth/2;
			if (!st.hasMoreTokens())
				throw new myException(cadre, prim
						+ " " + Logo.messages.getString("n_aime_pas") + liste
						+ Logo.messages.getString("comme_parametre"));
			li = st.nextToken();
			if (li.equals("-")) {
				if (st.hasMoreTokens())
					li = st.nextToken();
				coords[1] = -1;
			}
			coords[1] = Config.imageHeight/2 - Double.parseDouble(li) * coords[1];
		} catch (NumberFormatException e) {
			throw new myException(cadre, prim
					+ " " + Logo.messages.getString("n_aime_pas") + liste
					+ Logo.messages.getString("comme_parametre"));
		}
		if (st.hasMoreTokens())
			throw new myException(cadre, prim
					+ " " + Logo.messages.getString("n_aime_pas") + liste
					+ Logo.messages.getString("comme_parametre"));

	}
	protected void point(String liste) throws myException {
		if (null==coords) coords=new double[2];		
		extractCoords(liste,Logo.messages.getString("point"));
		if (coords[0]>0 && coords[1]>0 && coords[0]<Config.imageHeight && coords[1] < Config.imageWidth) {
			if (tortue.isPenReverse()) {
				g.setColor(couleurfond);
				g.setXORMode(tortue.couleurcrayon);
				
			} else {
				g.setColor(tortue.couleurcrayon);
				g.setPaintMode();
			}	
			if (rec==null) rec=new Rectangle2D.Double();
			 // High quality
			if (Config.quality==Config.QUALITY_HIGH){
				double width=tortue.getPenWidth();
				rec.setRect(coords[0]-width+0.5,coords[1]-width+0.5,
						2*width,2*width);
			}
			// Normal or Low Quality
			else{
				// penWidth is 2k or 2k+1??
				int intWidth=(int)(2*tortue.getPenWidth()+0.5);
				if (intWidth%2==1){
					double width=tortue.getPenWidth()-0.5;
//					System.out.println(coords[0]+" "+coords[1]);
					rec.setRect(coords[0]-width,coords[1]-width,
							2*width+1,2*width+1);
				}
				else {
					double width=tortue.getPenWidth();
					rec.setRect(coords[0]-width,coords[1]-width,
							2*width,2*width);	
				}
			}
				if (Config.penShape==Config.PEN_SHAPE_SQUARE){
					g.fill(rec);
				}
				else if (Config.penShape==Config.PEN_SHAPE_OVAL){
					if (null==arc) arc=new Arc2D.Double();
					arc.setArcByCenter(coords[0],coords[1],0,0,360,Arc2D.OPEN);
					g.draw(arc);
				}
				clip();
			}
	}

	protected void fpos(String liste) throws myException {
		if (null==coords) coords=new double[2];		
		extractCoords(liste,Logo.messages.getString("fpos"));
		oldx = tortue.corX;
		oldy = tortue.corY;
		montrecacheTortue(false);
		tortue.corX = coords[0];
		tortue.corY = coords[1];
		if (tortue.isPenDown()) {
			if (tortue.isPenReverse()) {
				g.setColor(couleurfond);
				g.setXORMode(tortue.couleurcrayon);
			} else {
				g.setColor(tortue.couleurcrayon);
				g.setPaintMode();
			}
			if (null==line) line=new Line2D.Double();
		/*	if (null==gp) gp=new GeneralPath();
			else gp.reset();*/
			if (oldx < tortue.corX){
				x1=oldx;y1=oldy;x2=tortue.corX;y2=tortue.corY;
			}
			if (oldx>tortue.corX){
				x2=oldx;y2=oldy;x1=tortue.corX;y1=tortue.corY;
			}
			else if (oldx==tortue.corX){
				if (oldy<tortue.corY){
					x2=oldx;y2=oldy;x1=tortue.corX;y1=tortue.corY;						
					}
				else{ 
					x1=oldx;y1=oldy;x2=tortue.corX;y2=tortue.corY;
				}
			}
			line.setLine(x1,y1,x2,y2);
		/*	// perpendicular vector
			nx=y1-y2;
			ny=x2-x1;
			length=Math.sqrt(nx*nx+ny*ny);
			factor=(1+tortue.getPenWidth())/length;
			vx=x2-x1;
			vy=y2-y1;
			gp.moveTo((float)(x1-vx*factor-nx*factor),
					(float)(y1-vy*factor-ny*factor));
			gp.lineTo((float)(x1-vx*factor+nx*factor),
					(float)(y1-vy*factor+ny*factor));		
			gp.lineTo((float)(x2+vx*factor+nx*factor),
					(float)(y2+vy*factor+ny*factor));
			gp.lineTo((float)(x2+vx*factor-nx*factor),
					(float)(y2+vy*factor-ny*factor));
			gp.lineTo((float)(x1-vx*factor-nx*factor),
					(float)(y1-vy*factor-ny*factor));*/
			g.draw(line);
			clip();
		}
		montrecacheTortue(true);
	}
	protected void ct_mt() {
		if (null == tortue.tort) {
			g.setXORMode(couleurfond);
			g.setColor(tortue.couleurcrayon);
			tortue.coord();
			BasicStroke crayon_actuel = (BasicStroke) g.getStroke();
			if (crayon_actuel.getLineWidth() == 1)
				g.draw(tortue.triangle);
			else {
				g.setStroke(crayon_triangle);
				g.draw(tortue.triangle);
				g.setStroke(crayon_actuel);
			}
		} else {
			g.setXORMode(couleurfond);
			double angle = Math.PI / 2 - tortue.angle;
			float x = (float) (tortue.corX * Math.cos(angle) + tortue.corY
					* Math.sin(angle));
			float y = (float) (-tortue.corX * Math.sin(angle) + tortue.corY
					* Math.cos(angle));
			g.rotate(angle);
			g.drawImage(tortue.tort, (int) x - tortue.largeur / 2,
					(int) y - tortue.hauteur / 2, cadre.getArdoise());
			g.rotate(-angle);
		}
/*		if (null==rec) rec=new Rectangle2D.Double();
		rec.setRect(tortue.corX - tortue.gabarit,
				tortue.corY - tortue.gabarit,
				tortue.gabarit * 2,
				tortue.gabarit * 2);
	*/
		clip();
	
/*		clip((int) (tortue.corX - tortue.gabarit),
				(int) (tortue.corY - tortue.gabarit),
				tortue.gabarit * 2, tortue.gabarit * 2);*/
	}
	protected void montrecacheTortue(boolean b) {
			g.setColor(couleurfond);
			for (int i = 0; i < tortues_visibles.size(); i++) {
				int id = Integer.parseInt(String.valueOf(tortues_visibles
						.get(i)));

				if (null == tortues[id].tort) {
					g.setXORMode(couleurfond);
					g.setColor(tortues[id].couleurmodedessin);
					tortues[id].coord();
					BasicStroke crayon_actuel = (BasicStroke) g.getStroke();
					if (crayon_actuel.getLineWidth() == 1)
						g.draw(tortues[id].triangle);
					else {
						g.setStroke(crayon_triangle);
						g.draw(tortues[id].triangle);
						g.setStroke(crayon_actuel);
					}
				} else {
					g.setXORMode(couleurfond);
					double angle = Math.PI / 2 - tortues[id].angle;
					float x = (float) (tortues[id].corX * Math.cos(angle) + tortues[id].corY
							* Math.sin(angle));
					float y = (float) (-tortues[id].corX * Math.sin(angle) + tortues[id].corY
							* Math.cos(angle));
					g.rotate(angle);
					g.drawImage(tortues[id].tort, (int) x
							- tortues[id].largeur / 2, (int) y
							- tortues[id].hauteur / 2, cadre.getArdoise());
					g.rotate(-angle);
				}
				/*if (null==rec) rec=new Rectangle2D.Double();
				rec.setRect(tortues[id].corX - tortues[id].gabarit,
						tortues[id].corY - tortues[id].gabarit,
						tortues[id].gabarit * 2,
						tortues[id].gabarit * 2);
				shape=rec;*/
				if (b) clip();
			}
		}
	
	
	
/*	private void montrecacheTortue() {
	//	Graphics2D g=(Graphics2D)dessin.getGraphics();
		g.setColor(couleurfond);
		for (int i = 0; i < tortues_visibles.size(); i++) {
			int id = Integer.parseInt(String.valueOf(tortues_visibles
					.get(i)));

			if (null == tortues[id].tort) {
				g.setXORMode(couleurfond);
				g.setColor(tortues[id].couleurmodedessin);
				tortues[id].coord();
				BasicStroke crayon_actuel = (BasicStroke) g.getStroke();
				if (crayon_actuel.getLineWidth() == 1)
					g.draw(tortues[id].triangle);
				else {
					g.setStroke(crayon_triangle);
					g.draw(tortues[id].triangle);
					g.setStroke(crayon_actuel);
				}
			} else {
				g.setXORMode(couleurfond);
				double angle = Math.PI / 2 - tortues[id].angle;
				float x = (float) (tortues[id].corX * Math.cos(angle) + tortues[id].corY
						* Math.sin(angle));
				float y = (float) (-tortues[id].corX * Math.sin(angle) + tortues[id].corY
						* Math.cos(angle));
				g.rotate(angle);
				g.drawImage(tortues[id].tort, (int) x
						- tortues[id].largeur / 2, (int) y
						- tortues[id].hauteur / 2, cadre.getArdoise());
				g.rotate(-angle);
			}
	/*		if (null==rec) rec=new Rectangle2D.Double();
			rec.setRect(tortues[id].corX - tortues[id].gabarit,
					tortues[id].corY - tortues[id].gabarit,
					tortues[id].gabarit * 2,
					tortues[id].gabarit * 2);
	
			clip();
		//	g.dispose();
		}
	}
*/
	protected void videecran() {
		// Delete all Gui Component
		Set set=gm.keySet();
		Iterator it=set.iterator();
		while(it.hasNext()){
			String element=it.next().toString();
			gui=((GuiComponent)gm.get(element)).getGuiObject();
			it.remove();
			if (SwingUtilities.isEventDispatchThread()){
				remove(gui);
				validate();
			}
			else {
				try{
					SwingUtilities.invokeAndWait(new Runnable(){
						public void run(){
							remove(gui);
							validate();						
						}
					});
				}
				catch(Exception e){}
			}
		}
		
		g.setPaintMode();
		couleurfond=Config.screencolor;
		g.setColor(Config.screencolor);
		g.fillRect(0, 0, Config.imageWidth,Config.imageHeight);
		
		// Draw Grid 
		g.setStroke(new BasicStroke(1));
		drawGrid();
		
		// Init Turtles
		if (null == tortues[0])
			tortues[0] = new Turtle(cadre);
		// The active turtle will be the turtle 0
		tortue = tortues[0]; 
		tortue.id = 0;
		// We delete all other turtles
		for (int i = 1; i < tortues.length; i++) { 
			tortues[i] = null;
		}
		tortues_visibles.removeAllElements();
		tortues_visibles.push("0");
		g.setColor(tortue.couleurcrayon);
		clip();
		tortue.init();
		tortue.setVisible(true);
		g.setStroke(new BasicStroke(1));
		montrecacheTortue(true);
	}

	protected void nettoie() {
		g.setPaintMode();
		g.setColor(couleurfond);
		g.fillRect(0, 0, Config.imageWidth,Config.imageHeight);
		drawGrid();
		/* Réinitialiser les tortues
		if (null == tortues[0])
			tortues[0] = new Tortue(cadre);
		tortue = tortues[0]; //la tortue active sera à présent la
		// numéro 0
		tortue.id = 0;
		for (int i = 1; i < tortues.length; i++) { //On élimine les
			// autres tortues
			tortues[i] = null;
		}
		tortues_visibles.removeAllElements();
		tortues_visibles.push("0");*/
		g.setColor(tortue.couleurcrayon);
		clip();

		if (tortue.isVisible())
			montrecacheTortue(true);
		else
			tortues_visibles=new Stack();
	}
	private int bornes_remplis_zone(int x, int y, int increment, int couleur_frontiere) {
//		System.out.println(x+" "+y);
		while (!meme_couleur(DrawPanel.dessin.getRGB(x, y) ,couleur_frontiere)) {
			DrawPanel.dessin.setRGB(x, y, couleur_frontiere);
			x = x + increment;
			if (!(x > 0 && x < Config.imageWidth-1))
				break;
		}
		return x - increment;
	}
	private boolean meme_couleur(int col1,int col2){
/*		if (Config.quality==Logo.QUALITY_HIGH){
			int rouge1 = (col1 >> 16) & 0xFF;
			int vert1 = (col1 >> 8) & 0xFF;
			int bleu1 = col1 & 0xFF;
			int rouge2 = (col2 >> 16) & 0xFF;
			int vert2 = (col2 >> 8) & 0xFF;
			int bleu2 = col2 & 0xFF;
			int tolerance=120;
			int diff_rouge=rouge1-rouge2;
			int diff_bleu=bleu1-bleu2;
			int diff_vert=vert1-vert2;
			boolean rouge;boolean vert; boolean bleu;
			if (rouge1>rouge2){
				if (rouge1-rouge2< 128 -rouge2/2) rouge=true;
				else rouge=false;
			}
			else{
				if (rouge2-rouge1<rouge2/2) rouge=true;
				else rouge=false;
			}
			if (vert1>vert2){
				if (vert1-vert2< 128 -vert2/2) vert=true;
				else vert=false;
			}
			else{
				if (vert2-vert1<vert2/2) vert=true;
				else vert=false;
			}
			if (bleu1>bleu2){
				if (bleu1-bleu2< 128 -bleu2/2) bleu=true;
				else bleu=false;
			}
			else{
				if (bleu2-bleu1<bleu2/2) bleu=true;
				else bleu=false;
			}

		return rouge&&bleu&&vert;	
//			if (Math.abs(rouge1-rouge2)<tolerance&&Math.abs(vert1-vert2)<tolerance&&Math.abs(bleu1-bleu2)<tolerance&&Math.abs(rouge1+bleu1+vert1-rouge2-bleu2-vert2)<450)
//			return true;
	//	else return false;
		}
		else{*/
			return (col1==col2);
		//}
	}
	protected void rempliszone() {
		montrecacheTortue(false);
		int x = (int) (tortue.corX + 0.5);
		int y = (int) (tortue.corY + 0.5);
		if (x > 0 & x < Config.imageWidth & y > 0 & y < Config.imageHeight) {
			int couleur_origine = DrawPanel.dessin.getRGB(x, y);
			int couleur_frontiere = tortue.couleurcrayon.getRGB();
		//	System.out.println(couleur_origine+" " +couleur_frontiere);
			Stack pile_germes = new Stack();
			boolean couleurs_differentes = !meme_couleur(couleur_origine,couleur_frontiere);
			if (couleurs_differentes)
				pile_germes.push(new Point(x, y));
			while (!pile_germes.isEmpty()) {

				Point p = (Point) pile_germes.pop();
				int xgerme = p.x;
				int ygerme = p.y;
				int xmax = bornes_remplis_zone(xgerme, ygerme, 1,
						couleur_frontiere);
				int xmin=0;
				if (xgerme>0) xmin = bornes_remplis_zone(xgerme - 1, ygerme, -1,
						couleur_frontiere);
				boolean ligne_dessus = false;
				boolean ligne_dessous = false;
				for (int i = xmin; i < xmax + 1; i++) {
					//on recherche les germes au dessus et au dessous
					if (ygerme > 0
							&& meme_couleur(DrawPanel.dessin.getRGB(i, ygerme - 1) ,couleur_frontiere)) {
						if (ligne_dessus)
							pile_germes.push(new Point(i - 1, ygerme - 1));
						ligne_dessus = false;
					} else {
						ligne_dessus = true;
						if (i == xmax && ygerme > 0)
							pile_germes.push(new Point(xmax, ygerme - 1));
					}
					if (ygerme < Config.imageHeight-1
							&& meme_couleur(DrawPanel.dessin.getRGB(i, ygerme + 1),couleur_frontiere)) {
						if (ligne_dessous)
							pile_germes.push(new Point(i - 1, ygerme + 1));
						ligne_dessous = false;
					} else {
						ligne_dessous = true;
						if (i == xmax && ygerme < Config.imageHeight-1)
							pile_germes.push(new Point(xmax, ygerme + 1));
					}
				}
			}
			clip();
			montrecacheTortue(true);
		}
	}

	private int bornes_remplis(int x, int y, int increment, int couleur_crayon,
			int couleur_origine) {
		while (DrawPanel.dessin.getRGB(x, y) == couleur_origine) {
			DrawPanel.dessin.setRGB(x, y, couleur_crayon);
			x = x + increment;
			if (!(x > 0 && x < Config.imageWidth-1))
				break;
		}
		return x - increment;
	}

	protected void remplis() {
		montrecacheTortue(false);
		int x = (int) (tortue.corX + 0.5);
		int y = (int) (tortue.corY + 0.5);
		if (x > 0 & x < Config.imageWidth & y > 0 & y < Config.imageHeight) {
		int couleur_origine = DrawPanel.dessin.getRGB(x, y);
		int couleur_crayon = tortue.couleurcrayon.getRGB();
		if (x > 0 & x < Config.imageWidth & y > 0 & y < Config.imageHeight) {
			Stack pile_germes = new Stack();
			boolean couleurs_differentes = !(couleur_origine == couleur_crayon);
			if (couleurs_differentes)
				pile_germes.push(new Point(x, y));
			while (!pile_germes.isEmpty()) {
				Point p = (Point) pile_germes.pop();
				int xgerme = p.x;
				int ygerme = p.y;
				//			System.out.println(xgerme+" "+ygerme);
				int xmax = bornes_remplis(xgerme, ygerme, 1, couleur_crayon,
						couleur_origine);
				int xmin=0;
				if (xgerme>0) xmin = bornes_remplis(xgerme - 1, ygerme, -1,
						couleur_crayon, couleur_origine);
				//				System.out.println("xmax "+xmax+"xmin "+xmin);
				boolean ligne_dessus = false;
				boolean ligne_dessous = false;
				for (int i = xmin; i < xmax + 1; i++) {
					//on recherche les germes au dessus et au dessous
					if (ygerme > 0
							&& DrawPanel.dessin.getRGB(i, ygerme - 1) != couleur_origine) {
						if (ligne_dessus)
							pile_germes.push(new Point(i - 1, ygerme - 1));
						ligne_dessus = false;
					} else {
						ligne_dessus = true;
						if (i == xmax && ygerme > 0)
							pile_germes.push(new Point(xmax, ygerme - 1));
					}
					if (ygerme < Config.imageHeight-1
							&& DrawPanel.dessin.getRGB(i, ygerme + 1) != couleur_origine) {
						if (ligne_dessous)
							pile_germes.push(new Point(i - 1, ygerme + 1));
						ligne_dessous = false;
					} else {
						ligne_dessous = true;
						if (i == xmax && ygerme < Config.imageHeight-1)
							pile_germes.push(new Point(xmax, ygerme + 1));
					}
				}
			}
			clip();
			montrecacheTortue(true);
		}
		}
	}
	protected void etiquette(String mot) {
		//	Graphics2D g = (Graphics2D) Ardoise.dessin.getGraphics();
		montrecacheTortue(false);
		double angle = Math.PI / 2 - tortue.angle;
		g.rotate(angle);
		g.setPaintMode();
		g.setColor(tortue.couleurcrayon);
		float x = (float) (tortue.corX * Math.cos(angle) + tortue.corY
				* Math.sin(angle));
		float y = (float) (-tortue.corX * Math.sin(angle) + tortue.corY
				* Math.cos(angle));
		g.setFont(Panel_Font.fontes[police_etiquette]
				.deriveFont((float) tortue.police));
		g.drawString(mot, x, y);
		g.rotate(-angle);		
		montrecacheTortue(true);
		if (classicMode) cadre.getArdoise().repaint();
	}
	// set Screen Color
	protected void fcfg(Color color) {
		couleurfond=color;
		nettoie();
	}
	
	protected void fcc(Color color) {
		if (tortue.isVisible()&&null==tortue.tort) montrecacheTortue(false);
		tortue.couleurcrayon = color;
		tortue.couleurmodedessin = color;
		if (tortue.isVisible()&&null==tortue.tort) montrecacheTortue(true);
	}
	protected void rafraichis(){ //Lorsqu'on change la taille de la zone de dessin
       g=(Graphics2D)DrawPanel.dessin.getGraphics();
		if (Config.quality==Config.QUALITY_HIGH) g.setRenderingHint(RenderingHints.KEY_ANTIALIASING,RenderingHints.VALUE_ANTIALIAS_ON);
	}

	protected void origine(){ // primitive origine
		try {
			fpos("0 0");
		} catch (myException e) {
		}
		if (tortue.isVisible())
			montrecacheTortue(false);
			tortue.cap = 0;
			tortue.angle = Math.PI / 2;
		if (tortue.isVisible())
			montrecacheTortue(true);
	}
	protected void guiposition(String id, String liste,String name) throws myException{
		if (guiExist(id)){
			if (null==coords) coords=new double[2];	
			extractCoords(liste,name);
			((GuiComponent)(gm.get(id))).setLocation((int)coords[0],(int)coords[1]);
		}
	}
	protected void guiDraw(String id) throws myException{
		if (guiExist(id)){
			GuiComponent gc=((GuiComponent)(gm.get(id)));
			add(gc.getGuiObject());
			validate();
			repaint();
		//	updateGuiComponents();
		}
	}
	private javax.swing.JComponent gui;
	protected void guiRemove(String id) throws myException{
		if (guiExist(id)){
			gui=((GuiComponent)gm.get(id)).getGuiObject();
			gm.remove(id);
			if (SwingUtilities.isEventDispatchThread()){
				remove(gui);
				validate();
			}
			else {
				try{
					SwingUtilities.invokeAndWait(new Runnable(){
						public void run(){
							remove(gui);
							validate();						
						}
					});
				}
				catch(Exception e){}
			}
			repaint();
		}
	}
	private StringBuffer extractList(String list) throws myException{
		StringBuffer sb=new StringBuffer();
		int compteur=0;
		int i=0;
		while(list.length()!=0){
			char c=list.charAt(i);
			if (c=='[') compteur++;
			else if (c==']') {
				if (compteur==0) return sb;
				else compteur--;
			}
			sb.append(c);
			i++;
		}
		throw new myException(cadre,"[ "+list+" "+Logo.messages.getString("pas_liste"));
	}
	
	protected void guiAction(String id, String liste) throws myException{
		if (guiExist(id)){
			GuiComponent gc=((GuiComponent)(gm.get(id)));
			// If gc is a JButton
			if (gc.isButton()){
				((GuiButton)gc).setAction(Utils.decoupe(liste));
				if (!gc.hasAction()){
					((javax.swing.JButton)gc.getGuiObject()).addActionListener(gc);
					gc.hasAction=true;
				}
			}
			// gc is a JcomboBox
			else if (gc.isMenu()){
				liste=liste.trim();
				int i=0;
				while(liste.length()!=0){
					if (liste.charAt(0)=='['){
						liste=liste.substring(1).trim();
						StringBuffer sb=extractList(liste);	
						liste=liste.substring(sb.length()+1).trim();
						((GuiMenu)gc).setAction(sb, i);
						i++;
					}
					else  throw new myException(cadre,liste.charAt(0)+" "+Logo.messages.getString("pas_liste"));
				}
				GuiMenu gm=(GuiMenu)gc;
				if (!gm.hasAction){
					gm.hasAction=true;
					((javax.swing.JComboBox)gc.getGuiObject()).addActionListener(gm);
				}
			}
		}
	}
	private boolean guiExist(String id) throws myException{
		if (gm.containsKey(id.toLowerCase())) return true;
		else throw new myException(cadre,Logo.messages.getString("no_gui")+" "+id);
	}
//	boolean access=false;
	private void clip(){
		if (classicMode){
			
			//access=true;
//			refresh();
			repaint();
	/*		if (SwingUtilities.isEventDispatchThread()){
				repaint();
			}
			else {
				try {
	
				SwingUtilities.invokeLater(new Runnable(){
					public void run(){
						repaint();			
					}
				});
			}
			catch(Exception e2){}
			}*/
		}
		/*Rectangle rec1=cadre.jScrollPane1.getViewport().getViewRect();
		boolean inter=sh.intersects(rec1);
		if (inter){
			if (classicMode){
				repaint();
			}
		}*/
	}
	public void setQuality(int id){
		if (id==Config.QUALITY_HIGH){
			g.setRenderingHint(RenderingHints.KEY_ANTIALIASING,RenderingHints.VALUE_ANTIALIAS_ON);
			g.setRenderingHint(RenderingHints.KEY_RENDERING,RenderingHints.VALUE_RENDER_QUALITY);
			g.setRenderingHint(RenderingHints.KEY_TEXT_ANTIALIASING,RenderingHints.VALUE_TEXT_ANTIALIAS_ON);
		}
		else if(id==Config.QUALITY_LOW){
			g.setRenderingHint(RenderingHints.KEY_ANTIALIASING,RenderingHints.VALUE_ANTIALIAS_OFF);
			g.setRenderingHint(RenderingHints.KEY_RENDERING,RenderingHints.VALUE_RENDER_SPEED);
			g.setRenderingHint(RenderingHints.KEY_TEXT_ANTIALIASING,RenderingHints.VALUE_TEXT_ANTIALIAS_OFF);
		}
		else { //normal
			g.setRenderingHint(RenderingHints.KEY_ANTIALIASING,RenderingHints.VALUE_ANTIALIAS_DEFAULT);
			g.setRenderingHint(RenderingHints.KEY_RENDERING,RenderingHints.VALUE_RENDER_DEFAULT);
			g.setRenderingHint(RenderingHints.KEY_TEXT_ANTIALIASING,RenderingHints.VALUE_TEXT_ANTIALIAS_DEFAULT);
		}
	}
	public  void change_image_tortue(Application cadre, String chemin) {
		if (tortue.isVisible())
			montrecacheTortue(false);
		if (chemin.equals("tortue0.png")) {
			tortue.tort = null;
			tortue.largeur = 26;
			tortue.hauteur = 26;
		} else {
			//ON teste tout d'abord si le chemin est valide
			if (null == Utils.class.getResource(chemin))
				chemin = "tortue1.png";
			tortue.tort = Toolkit.getDefaultToolkit().getImage(
					Utils.class.getResource(chemin));
			MediaTracker tracker = new MediaTracker(cadre);
			tracker.addImage(tortue.tort, 0);
			try {
				tracker.waitForID(0);
			} catch (InterruptedException e1) {
			}
			double largeur_ecran = Toolkit.getDefaultToolkit().getScreenSize()
					.getWidth();
			// On fait attention à la résolution de l'utilisateur
			double facteur = largeur_ecran / 1024.0;

			if ((int) (facteur + 0.001) != 1) {
				tortue.largeur = tortue.tort.getWidth(cadre);
				tortue.hauteur = tortue.tort.getHeight(cadre);
				tortue.tort = tortue.tort.getScaledInstance(
						(int) (facteur * tortue.largeur),
						(int) (facteur * tortue.hauteur),
						Image.SCALE_SMOOTH);
				tracker = new MediaTracker(cadre);
				tracker.addImage(tortue.tort, 0);
				try {
					tracker.waitForID(0);
				} catch (InterruptedException e1) {
				}
			}
			tortue.largeur = tortue.tort.getWidth(cadre);
			tortue.hauteur = tortue.tort.getHeight(cadre);
		}
		tortue.gabarit = Math.max(tortue.hauteur,
				tortue.largeur);
		if (tortue.isVisible())
			montrecacheTortue(true);

	}
	// animation 
	protected void setAnimation(boolean predic){
		if (predic==classicMode){
			if (predic) {
				cadre.getHistoryPanel().active_animation();
			}
			else {
				cadre.getHistoryPanel().stop_animation();
				repaint();
			}
		}
	}
	
	protected void setGraphicsFont(Font f){
		g.setFont(f);
	}
	protected Font getGraphicsFont(){
		return g.getFont();
	}
	protected void setStroke(Stroke st){
		g.setStroke(st);
	}
	public Color getScreenBackground(){
		return couleurfond;
	}
	protected void setScreenBackground(Color c){
		couleurfond=c;
	}
	public void setNumberOfTurtles(int id){
		Config.maxTurtles = id;
		Turtle[] tampon = (Turtle[]) tortues.clone();
		tortues = new Turtle[id];
		int borne_sup=Math.min(tampon.length,tortues.length);
		for(int i=0;i<borne_sup;i++){
			tortues[i]=tampon[i];
		}
		for(int i=tortues_visibles.size()-1;i>-1;i--){
			int integer=Integer.parseInt(tortues_visibles.get(i).toString());
			if (integer>=id){
				tortues_visibles.remove(i);
			}
		}
	}
	protected void initGraphics(){
		police_etiquette=Application.police;
		//		 init all turtles
		tortues = new Turtle[Config.maxTurtles];
		tortues_visibles=new Stack();
		tortue=new Turtle(cadre);
		tortue.id = 0;
		tortues_visibles.push(String.valueOf("0"));
		for (int i = 0; i < tortues.length; i++) { //initialisation de
			// l'ensemble des tortues
			if (i == 0)
				tortues[i] = tortue;
			else
				tortues[i] = null;
		}

		g=(Graphics2D)dessin.getGraphics();
		couleurfond=Config.screencolor;
		setQuality(Config.quality);
		MediaTracker tracker;
	    g.setColor(Config.screencolor);
	    g.fillRect(0,0,Config.imageWidth,Config.imageHeight);
	     drawGrid();
	    g.setColor(Config.screencolor);
	    
	    
	    if (0==Config.activeTurtle) {
	       	g.setXORMode(couleurfond);
	    	tortue.coord();
	       	g.setColor(tortue.couleurcrayon);
	       	g.draw(tortue.triangle);
	    }
	    else {
	      	g.setXORMode(couleurfond);
	    	tracker=new MediaTracker(cadre);
	        tracker.addImage(tortue.tort,0);
	        try{tracker.waitForID(0);}
	        catch(InterruptedException e){}
	           if (tracker.checkID(0))  g.drawImage(tortue.tort, Config.imageWidth/2 - tortue.largeur / 2,
	                    Config.imageHeight/2 - tortue.hauteur/2, cadre.getArdoise());
	      }
	    
	  ////////  clip(); ici
	}
	public void zoom(double d){
		// Resize all GuiComponent
		Set set=gm.keySet();
		Iterator it=set.iterator();
		while (it.hasNext()){
			String element=it.next().toString();
			GuiComponent gui=(GuiComponent)gm.get(element);
			gui.getGuiObject().setSize((int)(gui.getOriginalWidth()*d),
					(int)(gui.getOriginalHeight()*d) );
			Font f=gui.getGuiObject().getFont();
			gui.getGuiObject().setFont(f.deriveFont((float)(Config.police.getSize()*d)));
			double x=gui.getLocation().x/zoom;
			double y=gui.getLocation().y/zoom;
			gui.setLocation((int)(x*d),(int)(y*d));
			
		}
		
	
		double oldZoom=zoom;
		zoom=d;
		javax.swing.JViewport jv=cadre.jScrollPane1.getViewport();
		Point p=jv.getViewPosition();
		Rectangle r=jv.getVisibleRect();
		/* 
		 * 		-------------------------------------
		 * 		|									|
		 *      |  	-------------------------		|
		 * 		|	|						|		|
		 * 		|	|						|		|
		 * 		|	|			x			|  --> CenterView Point of the rectangle
		 * 		|	|						|		|
		 * 		|	|						|		|
		 * 		|	-------------------------		|
		 * 		-------------------------------------
		 * */
		Point centerView=new Point(p.x+Math.min(r.width,(int)(Config.imageWidth*oldZoom))/2
				,p.y+Math.min(r.height,(int)(Config.imageHeight*oldZoom))/2);
		cadre.calculateMargin();
		cadre.getArdoise().setPreferredSize(new java.awt.Dimension(
				(int)(Config.imageWidth*zoom)
				,(int)(Config.imageHeight*zoom)));
		cadre.getArdoise().revalidate();
		cadre.getArdoise().repaint();
		jv.setViewPosition(new Point(
				(int)(centerView.x/oldZoom*zoom-r.width/2),
				(int)(centerView.y/oldZoom*zoom-r.height/2)));
		
	}
	private void drawGrid(){
		if (Config.drawGrid){
			g.setColor(Color.LIGHT_GRAY);
			for (int i=Config.imageWidth/2%Config.XGrid;i<Config.imageWidth;i=i+Config.XGrid)
				g.drawLine(i, 0, i, Config.imageHeight);

			for (int i=Config.imageHeight/2%Config.YGrid;i<Config.imageHeight;i=i+Config.YGrid)
				g.drawLine(0,i, Config.imageWidth, i);
		}
	}
	// In animation mode, we have to wait for the drawing o be finished before modifying graphics.
	// Thread must be synchronized.
	protected synchronized void refresh(){
		repaint();
		try{
			wait();
		}
		catch(InterruptedException e){}		
	
	}

  protected synchronized void paintComponent(Graphics graph){
	  super.paintComponent(graph);
	  Graphics2D g2d=(Graphics2D)graph;
	  if (null==shape){
		  g2d.setClip(cadre.jScrollPane1.getViewport().getViewRect());
	  }
	  else {
		  g2d.setClip(shape);
		  shape=null;
	  }
	   g2d.scale(DrawPanel.zoom,DrawPanel.zoom);
	  g2d.drawImage(dessin,0,0,this);
	  g2d.scale(1/DrawPanel.zoom,1/DrawPanel.zoom);
	  notify();
  }
  
	 public void active_souris(){
		 lissouris=false;
		 addMouseListener(cs);
		 addMouseMotionListener(bs);
	 }
	 public void stop_souris(){
		 removeMouseListener(cs);
		 removeMouseMotionListener(bs);
	 }
	 public boolean get_lissouris(){
		 return lissouris;
	 }
	 public int get_bouton_souris(){
		 lissouris=false;
		 return bouton_souris;
	 }
	 public String get_possouris(){
		 lissouris=false;
		 return possouris;
	 }
	 class Click_Souris extends MouseAdapter{
		 public void mouseClicked(MouseEvent ev){
			 lissouris=true;
			 bouton_souris=ev.getButton();
			 Point point=ev.getPoint();
			 possouris="[ "+(point.x-Config.imageWidth/2)+" "+(Config.imageHeight/2-point.y)+" ] ";
		 }
   }
   class Bouge_Souris extends MouseMotionAdapter{
		 public void mouseMoved(MouseEvent ev){
			 lissouris=true;
			 bouton_souris=0;
			 Point point=ev.getPoint();
			 possouris="[ "+(point.x-Config.imageWidth/2)+" "+(Config.imageHeight/2-point.y)+" ] ";
		 }
	 }
   protected void addToGuiMap(GuiComponent gc) throws xlogo.utils.myException{
	   gm.put(gc);
   }
	
}